﻿using System;
using System.Collections.Generic;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    public static class RedisClient
    {
        static Socket _socket;

        static RedisCoder _redisCoder;

        static NetworkStream _networkStream;

        static bool IsConnected { get; set; } = false;


        static RedisClient()
        {
            _socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            _socket.NoDelay = true;
            _redisCoder = new RedisCoder();

        }

        public static bool Connect(string ip, int port)
        {
            try
            {
                _socket.Connect(ip, port);

                _networkStream = new NetworkStream(_socket, true);

                IsConnected = true;

                Task.Factory.StartNew(() =>
                {
                    byte[] myReadBuffer = new byte[1024];

                    while (IsConnected)
                    {
                        do
                        {
                            var size = _networkStream.Read(myReadBuffer, 0, myReadBuffer.Length);

                            var data = myReadBuffer.AsSpan().Slice(0, size).ToArray();

                            Console.WriteLine(string.Join(",", data));

                            _redisCoder.Enqueue(data);
                        }
                        while (_networkStream.DataAvailable);
                    }
                });
            }
            catch (Exception ex)
            {

            }
            return IsConnected;
        }

        public static string Request(string cmd, params string[] args)
        {
            var scmd = _redisCoder.Code(cmd, args);

            Console.WriteLine(scmd);

            var data = Encoding.UTF8.GetBytes(scmd);

            _networkStream.Write(data);

            var result = _redisCoder.Decode();
            Console.WriteLine(result);
            return result;
        }


    }
}
