﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace ConsoleApp1
{
    public class RedisCoder
    {
        private readonly AutoResetEvent _coderDecoderSync = new AutoResetEvent(true);

        string _commandName = string.Empty;

        static ConcurrentQueue<byte[]> _queue = new ConcurrentQueue<byte[]>();

        static List<byte> _dataCache = new List<byte>();

        public string Code(string command, params string[] @params)
        {
            _coderDecoderSync.WaitOne();

            _commandName = command;

            var sb = new StringBuilder();

            sb.AppendLine("*" + (@params.Length + 1));

            sb.AppendLine("$" + Encoding.UTF8.GetBytes(command).Length);
            sb.AppendLine(command);

            foreach (var param in @params)
            {
                var length = Encoding.UTF8.GetBytes(param).Length;
                sb.AppendLine("$" + length);
                sb.AppendLine(param);
            }
            return sb.ToString();
        }

        public void Enqueue(byte[] data)
        {
            _queue.Enqueue(data);
        }

        public string Decode()
        {
            StringBuilder sb = new StringBuilder();

            while (true)
            {
                if (_queue.TryDequeue(out byte[] result))
                {
                    _dataCache.AddRange(result);

                    while (true)
                    {
                        var s = _dataCache.AsReadOnly();

                        var index = s.IndexOf((byte)13);

                        if (index == -1)
                            break;

                        var next = index + 1;

                        if (s.Count == next + 1)
                        {
                            if (s[next] == (byte)10)
                            {
                                var buffer = _dataCache.ToArray();

                                _dataCache.Clear();

                                _coderDecoderSync.Set();

                                sb.Append(Encoding.UTF8.GetString(buffer));
                            }
                        }
                        else if (s.Count > next + 1)
                        {
                            if (s[next] == (byte)10)
                            {
                                var buffer = new byte[next + 1];

                                _dataCache.CopyTo(0, buffer, 0, buffer.Length);

                                _dataCache.RemoveRange(0, buffer.Length);

                                sb.Append(Encoding.UTF8.GetString(buffer));
                            }
                        }

                        if (_dataCache.Count == 0)
                        {
                            _coderDecoderSync.Set();

                            return sb.ToString();
                        }
                    }

                }
                else
                {
                    Thread.Sleep(1);
                }
            }


        }
    }
}
